<?php
    session_start();
    $_SESSION['username'] = "Register";
    $_SESSION['usertype'] = "SuperUser";
?>
<!doctype html>
<html lang="en">
<head>
    <meta charset="utf-8"/>
    <title>RaSmatin Install</title>
    <style type="text/css">
        html, body
        {
            background-color: white !important;
        }

        #status
        {
            position: relative;
            margin: 10px auto;
            margin-top: 40px;
            width: 1000px;
            border: 2px solid #1E5799;
        }

        #status>div
        {
            display: block;
            width: 25%;
            float: left;
            text-align: center;
            margin-top: -12.5px;
        }

        #status .point
        {
            display: inline-block;
            width: 24px;
            height: 24px;
            line-height: 22px;
            vertical-align: middle;
            text-align: center;
            background-color: white;
            border: 1px solid #1E5799;
            border-radius: 12px;
            -webkit-box-sizing: border-box;
            -moz-box-sizing: border-box;
            box-sizing: border-box;
        }

        #status .point.active
        {
            background-color: #1E5799;
            color: white;
        }

        #status .point.done
        {
            background-color: #15bbff;
            color: white;
        }

        #status .point p
        {
            margin: 0;
        }

    </style>
    <link rel="stylesheet" href="css/template.css"/>
    <link rel="stylesheet" href="css/inputfield.css"/>
    <script type="text/javascript" src="js/jquery.js"></script>
    <script type="text/javascript" src="js/permissions.js"></script>
</head>
<body>
    <div id="status">
        <div><div class="point"><p>1</p></div></div>
        <div><div class="point"><p>2</p></div></div>
        <div><div class="point"><p>3</p></div></div>
        <div><div class="point"><p>4</p></div></div>
    </div>
    <div id="content">
        <noscript>
            Turn on JavaScript.
        </noscript>
    </div>
    <div id="loader" style="display: none; height: 100%; width: 100%; position: fixed; top:0; left:0;
		background: url(images/ajax-loader.gif) center center no-repeat rgba(0,0,0,0.8); z-index:1000;"></div>
    <script type="text/javascript">
        $(document).ready(function()
        {
            setActive(0);
        });



        function loadPage(url, data, output, skippermission)
        {
            if(!skippermission && !checkPermissions())
                return;

            if($.isFunction(data))
            {
                data = data();
            }
            else if(data == undefined)
            {
                data = {};
                data['initial']=true;
            }

            $.ajax({
                method: "POST",
                url: url,
                data: data
            })
            .done(function(msg)
            {
                $(output).empty();
                $(output).append(msg);
                checkPermissions();
            });
            return false;

        }

        function setActive(index)
        {
            if(index == 0)
            {
                loadPage('install/install_mysql.php', undefined, '#content');
            }
            else if(index == 1)
            {
                loadPage('php/settings/user/new.php', undefined, '#content');
            }
            else if(index == 2)
            {
                loadPage('php/settings/RaSmatin/configuration/upload.php', undefined, '#content');
            }
            else if(index == 3)
            {
                loadPage('install/finished.php', undefined, '#content', true);
            }

            $('#status').find('.point').each(function(i)
            {
               if(i < index)
               {
                   $(this).removeClass('active');
                   $(this).addClass('done');
               }
                else if(i == index)
               {
                   $(this).addClass('active');
               }
                else
               {
                   return false;
               }
            });
        }

        $( document ).ajaxStart(function() {
            $( "#loader" ).show();
        });
        $(document).ajaxStop(function() {
            $( "#loader" ).hide();
        });
        $(document).ajaxError(function(xhr, status)
        {
			if(status.status == 404)
			{
				alert("404: page not found");
			}
			else if(status.status == 403)
			{
				alert("403: Access denied/forbidden")
			}
			else if(status.status == 500)
			{
				alert("500: Internal server error")
			}
			else
			{
				alert(status.status);
				alert(VarAjaxError);
			}
            $( "#loader" ).hide();
        });
    </script>
</body>
</html>

