#!/bin/bash
function containsOrAppend()
{
	file=$1
	string=$2
	
	replace=$(sed "s/*/\\\*/g" <<< "$string")
	if grep -q "$replace" "$file"; 
	then
		string=$(sed "s/\//\\\\\//g" <<< "$replace")
		sed "s/.*$string.*/$string/" "$file" > "$file.bak";
		mv "$file.bak" "$file"
	else
		echo "$string" >> $file
	fi
}

if [[ $EUID -ne 0 ]]; then
   echo "This script must be run as root" 1>&2
   exit 1
fi

cd $(dirname $0)



mkdir -p ApacheConfigBackup
cp /etc/apache2/apache2.conf ApacheConfigBackup
cp /etc/apache2/ports.conf ApacheConfigBackup

containsOrAppend /etc/apache2/apache2.conf "Include /etc/RaSmatinServer/apache.conf"
containsOrAppend /etc/apache2/ports.conf "NameVirtualHost *:8764"
containsOrAppend /etc/apache2/ports.conf "Listen 8764"
file=install/apache.conf
string=$(sed "s/\//\\\\\//g" <<< "$PWD")
sed "s/.*DocumentRoot.*/\tDocumentRoot $string/" "$file" > "$file.bak";
mv "$file.bak" "$file"
sed "s/.*<Directory .*>.*/\t<Directory $string>/" "$file" > "$file.bak";
mv "$file.bak" "$file"
mkdir -p /etc/RaSmatinServer
mkdir -p /etc/RaSmatinServer/CustomElements
if [ ! -f /etc/RaSmatinServer/RaSmatin.RaUC ]; then
	echo "" > /etc/RaSmatinServer/RaSmatin.RaUC
fi
chown www-data:www-data -R /etc/RaSmatinServer
chmod 722 -R /etc/RaSmatinServer

cp "$file" /etc/RaSmatinServer/apache.conf

mkdir -p /var/log/RaSmatinServer
chown www-data:www-data -R /var/log/RaSmatinServer
echo "" > /var/log/RaSmatinServer/output.log

service apache2 restart

chown www-data:www-data .
chown www-data:www-data php/main
chown www-data:www-data index.php
chown -R www-data:www-data install
chown -R www-data:www-data images/categories
chown -R www-data:www-data images/language
