-- MySQL dump 10.13  Distrib 5.5.50, for debian-linux-gnu (armv7l)
--
-- Host: localhost    Database: RaSmatin
-- ------------------------------------------------------
-- Server version	5.5.50-0+deb7u2

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;
/*!40103 SET @OLD_TIME_ZONE=@@TIME_ZONE */;
/*!40103 SET TIME_ZONE='+00:00' */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;

--
-- Table structure for table `categories`
--

DROP TABLE IF EXISTS `categories`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `categories` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(50) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL,
  `image` varchar(60) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `name` (`name`),
  UNIQUE KEY `id_UNIQUE` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8mb4;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `config`
--

DROP TABLE IF EXISTS `config`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `config` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `key` varchar(45) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL,
  `value` varchar(200) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `key_UNIQUE` (`key`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `diagram_data`
--

DROP TABLE IF EXISTS `diagram_data`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `diagram_data` (
  `datetime` datetime NOT NULL COMMENT '		',
  `name` varchar(45) NOT NULL,
  `value` varchar(45) CHARACTER SET latin1 NOT NULL,
  KEY `fk_name_idx` (`name`),
  CONSTRAINT `fk_name` FOREIGN KEY (`name`) REFERENCES `items` (`name`) ON DELETE NO ACTION ON UPDATE NO ACTION
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `favourites`
--

DROP TABLE IF EXISTS `favourites`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `favourites` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `userid` int(11) NOT NULL,
  `name` varchar(45) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `UNIQUE` (`userid`,`name`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8mb4;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `favouriteslist`
--

DROP TABLE IF EXISTS `favouriteslist`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `favouriteslist` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `favouriteid` int(11) NOT NULL,
  `name` varchar(45) NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `UNIQUE` (`favouriteid`,`name`),
  KEY `fk_favourite_idx` (`favouriteid`),
  KEY `fk_name_idx` (`name`),
  CONSTRAINT `favouriteslist_ibfk_1` FOREIGN KEY (`name`) REFERENCES `items` (`name`) ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT `fk_favourite` FOREIGN KEY (`favouriteid`) REFERENCES `favourites` (`id`) ON DELETE NO ACTION ON UPDATE NO ACTION
) ENGINE=InnoDB AUTO_INCREMENT=35 DEFAULT CHARSET=utf8mb4;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `items`
--

DROP TABLE IF EXISTS `items`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `items` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(45) NOT NULL,
  `plugid` int(11) DEFAULT NULL,
  `moduleid` int(11) DEFAULT NULL,
  `variabletype` varchar(45) NOT NULL,
  `readonly` tinyint(1) NOT NULL DEFAULT '1',
  `prefix` varchar(45) DEFAULT NULL,
  `suffix` varchar(45) DEFAULT NULL,
  `categoryid` int(11) NOT NULL DEFAULT '-1',
  `mainlevelid` int(11) NOT NULL DEFAULT '-1',
  `type` enum('plug','variable') DEFAULT NULL,
  `startvalue` varchar(45) DEFAULT '0',
  `format` varchar(45) DEFAULT NULL,
  `refreshtime` int(11) DEFAULT NULL,
  `logtime` int(11) DEFAULT NULL,
  `correction` varchar(45) DEFAULT NULL,
  `min` varchar(45) DEFAULT NULL,
  `max` varchar(45) DEFAULT NULL,
  `secondaxis` tinyint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`name`),
  UNIQUE KEY `id_UNIQUE` (`id`),
  KEY `fk_category_idx` (`categoryid`),
  KEY `fk_mainlevel_idx` (`mainlevelid`),
  KEY `fk_module_idx` (`moduleid`),
  KEY `fk_variabletype_idx` (`variabletype`),
  CONSTRAINT `fk_category` FOREIGN KEY (`categoryid`) REFERENCES `categories` (`id`) ON DELETE NO ACTION ON UPDATE NO ACTION,
  CONSTRAINT `fk_mainlevel` FOREIGN KEY (`mainlevelid`) REFERENCES `levels` (`id`) ON DELETE NO ACTION ON UPDATE NO ACTION,
  CONSTRAINT `fk_module` FOREIGN KEY (`moduleid`) REFERENCES `modules` (`id`) ON DELETE NO ACTION ON UPDATE NO ACTION,
  CONSTRAINT `fk_variabletype` FOREIGN KEY (`variabletype`) REFERENCES `variabletypes` (`name`) ON DELETE NO ACTION ON UPDATE NO ACTION
) ENGINE=InnoDB AUTO_INCREMENT=41 DEFAULT CHARSET=utf8mb4;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `language`
--

DROP TABLE IF EXISTS `language`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `language` (
  `idlanguage` int(11) NOT NULL AUTO_INCREMENT,
  `tag` varchar(45) CHARACTER SET utf8 NOT NULL,
  `Deutsch` varchar(500) CHARACTER SET utf8 DEFAULT NULL,
  `English` varchar(500) CHARACTER SET utf8 DEFAULT NULL,
  `test` varchar(500) CHARACTER SET utf8 DEFAULT NULL,
  PRIMARY KEY (`idlanguage`,`tag`),
  UNIQUE KEY `tag_UNIQUE` (`tag`)
) ENGINE=InnoDB AUTO_INCREMENT=204 DEFAULT CHARSET=utf8mb4;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `levels`
--

DROP TABLE IF EXISTS `levels`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `levels` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `mainid` int(11) NOT NULL,
  `name` varchar(45) CHARACTER SET latin1 NOT NULL,
  PRIMARY KEY (`id`,`name`),
  UNIQUE KEY `name_UNIQUE` (`name`),
  UNIQUE KEY `id_UNIQUE` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=7 DEFAULT CHARSET=utf8mb4;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `modules`
--

DROP TABLE IF EXISTS `modules`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `modules` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `moduleid` int(11) NOT NULL,
  `name` varchar(45) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL,
  `hwid` int(11) NOT NULL,
  `serial` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `id` (`id`,`moduleid`,`name`),
  UNIQUE KEY `moduleid_UNIQUE` (`moduleid`),
  UNIQUE KEY `name_UNIQUE` (`name`),
  UNIQUE KEY `serial_UNIQUE` (`serial`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8mb4;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `overview`
--

DROP TABLE IF EXISTS `overview`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `overview` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `x` int(11) NOT NULL,
  `y` int(11) NOT NULL,
  `width` int(11) NOT NULL,
  `height` int(11) NOT NULL,
  `display` varchar(45) DEFAULT NULL,
  `json` text,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=11 DEFAULT CHARSET=utf8mb4;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `plugtypes`
--

DROP TABLE IF EXISTS `plugtypes`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `plugtypes` (
  `variabletype` varchar(45) NOT NULL,
  `readonly` tinyint(1) NOT NULL,
  `name` varchar(45) NOT NULL,
  PRIMARY KEY (`variabletype`,`readonly`),
  UNIQUE KEY `name_UNIQUE` (`name`),
  CONSTRAINT `fk_variable` FOREIGN KEY (`variabletype`) REFERENCES `variabletypes` (`name`) ON DELETE NO ACTION ON UPDATE NO ACTION
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `users`
--

DROP TABLE IF EXISTS `users`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `users` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(45) CHARACTER SET latin1 NOT NULL,
  `password` varchar(128) CHARACTER SET latin1 NOT NULL,
  `type` varchar(45) CHARACTER SET latin1 NOT NULL,
  PRIMARY KEY (`id`,`name`),
  UNIQUE KEY `name_UNIQUE` (`name`),
  UNIQUE KEY `id_UNIQUE` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8mb4;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Temporary table structure for view `v_favourites`
--

DROP TABLE IF EXISTS `v_favourites`;
/*!50001 DROP VIEW IF EXISTS `v_favourites`*/;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
/*!50001 CREATE TABLE `v_favourites` (
  `favouriteid` tinyint NOT NULL,
  `favouritename` tinyint NOT NULL,
  `username` tinyint NOT NULL,
  `id` tinyint NOT NULL,
  `name` tinyint NOT NULL,
  `type` tinyint NOT NULL,
  `communicateid` tinyint NOT NULL,
  `variabletype` tinyint NOT NULL,
  `readonly` tinyint NOT NULL,
  `min` tinyint NOT NULL,
  `max` tinyint NOT NULL,
  `prefix` tinyint NOT NULL,
  `suffix` tinyint NOT NULL,
  `categoryid` tinyint NOT NULL,
  `category` tinyint NOT NULL,
  `mainlevelid` tinyint NOT NULL,
  `level` tinyint NOT NULL
) ENGINE=MyISAM */;
SET character_set_client = @saved_cs_client;

--
-- Temporary table structure for view `v_levels`
--

DROP TABLE IF EXISTS `v_levels`;
/*!50001 DROP VIEW IF EXISTS `v_levels`*/;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
/*!50001 CREATE TABLE `v_levels` (
  `id` tinyint NOT NULL,
  `mainid` tinyint NOT NULL,
  `name` tinyint NOT NULL,
  `sublevels` tinyint NOT NULL
) ENGINE=MyISAM */;
SET character_set_client = @saved_cs_client;

--
-- Temporary table structure for view `v_plugs`
--

DROP TABLE IF EXISTS `v_plugs`;
/*!50001 DROP VIEW IF EXISTS `v_plugs`*/;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
/*!50001 CREATE TABLE `v_plugs` (
  `id` tinyint NOT NULL,
  `name` tinyint NOT NULL,
  `moduleid` tinyint NOT NULL,
  `plugid` tinyint NOT NULL,
  `communicateid` tinyint NOT NULL,
  `variabletype` tinyint NOT NULL,
  `readonly` tinyint NOT NULL,
  `plugtype` tinyint NOT NULL,
  `min` tinyint NOT NULL,
  `max` tinyint NOT NULL,
  `refreshtime` tinyint NOT NULL,
  `prefix` tinyint NOT NULL,
  `suffix` tinyint NOT NULL,
  `categoryid` tinyint NOT NULL,
  `category` tinyint NOT NULL,
  `mainlevelid` tinyint NOT NULL,
  `level` tinyint NOT NULL,
  `logtime` tinyint NOT NULL,
  `correction` tinyint NOT NULL,
  `format` tinyint NOT NULL
) ENGINE=MyISAM */;
SET character_set_client = @saved_cs_client;

--
-- Temporary table structure for view `v_plugs_variables`
--

DROP TABLE IF EXISTS `v_plugs_variables`;
/*!50001 DROP VIEW IF EXISTS `v_plugs_variables`*/;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
/*!50001 CREATE TABLE `v_plugs_variables` (
  `id` tinyint NOT NULL,
  `name` tinyint NOT NULL,
  `type` tinyint NOT NULL,
  `communicateid` tinyint NOT NULL,
  `tableid` tinyint NOT NULL,
  `variabletype` tinyint NOT NULL,
  `readonly` tinyint NOT NULL,
  `min` tinyint NOT NULL,
  `max` tinyint NOT NULL,
  `prefix` tinyint NOT NULL,
  `suffix` tinyint NOT NULL,
  `categoryid` tinyint NOT NULL,
  `category` tinyint NOT NULL,
  `mainlevelid` tinyint NOT NULL,
  `level` tinyint NOT NULL,
  `logtime` tinyint NOT NULL
) ENGINE=MyISAM */;
SET character_set_client = @saved_cs_client;

--
-- Temporary table structure for view `v_variables`
--

DROP TABLE IF EXISTS `v_variables`;
/*!50001 DROP VIEW IF EXISTS `v_variables`*/;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
/*!50001 CREATE TABLE `v_variables` (
  `id` tinyint NOT NULL,
  `name` tinyint NOT NULL,
  `communicateid` tinyint NOT NULL,
  `variabletype` tinyint NOT NULL,
  `readonly` tinyint NOT NULL,
  `min` tinyint NOT NULL,
  `max` tinyint NOT NULL,
  `prefix` tinyint NOT NULL,
  `suffix` tinyint NOT NULL,
  `categoryid` tinyint NOT NULL,
  `category` tinyint NOT NULL,
  `mainlevelid` tinyint NOT NULL,
  `level` tinyint NOT NULL,
  `logtime` tinyint NOT NULL,
  `startvalue` tinyint NOT NULL,
  `format` tinyint NOT NULL
) ENGINE=MyISAM */;
SET character_set_client = @saved_cs_client;

--
-- Table structure for table `variabletypes`
--

DROP TABLE IF EXISTS `variabletypes`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `variabletypes` (
  `name` varchar(45) NOT NULL,
  PRIMARY KEY (`name`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `weather`
--

DROP TABLE IF EXISTS `weather`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `weather` (
  `sensor` varchar(45) CHARACTER SET latin1 NOT NULL,
  `min` int(11) NOT NULL,
  `max` varchar(45) CHARACTER SET latin1 NOT NULL,
  `color` varchar(45) CHARACTER SET latin1 NOT NULL,
  `unit` varchar(45) CHARACTER SET latin1 NOT NULL,
  `major` double NOT NULL,
  `minor` double NOT NULL,
  `showMinor` varchar(45) CHARACTER SET latin1 NOT NULL,
  `name` varchar(45) CHARACTER SET latin1 NOT NULL,
  `color2` varchar(45) CHARACTER SET latin1 NOT NULL,
  UNIQUE KEY `sensor_UNIQUE` (`sensor`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Final view structure for view `v_favourites`
--

/*!50001 DROP TABLE IF EXISTS `v_favourites`*/;
/*!50001 DROP VIEW IF EXISTS `v_favourites`*/;
/*!50001 SET @saved_cs_client          = @@character_set_client */;
/*!50001 SET @saved_cs_results         = @@character_set_results */;
/*!50001 SET @saved_col_connection     = @@collation_connection */;
/*!50001 SET character_set_client      = utf8 */;
/*!50001 SET character_set_results     = utf8 */;
/*!50001 SET collation_connection      = utf8_general_ci */;
/*!50001 CREATE ALGORITHM=UNDEFINED */
/*!50013 DEFINER=`root`@`localhost` SQL SECURITY DEFINER */
/*!50001 VIEW `v_favourites` AS select `favouriteslist`.`favouriteid` AS `favouriteid`,`favourites`.`name` AS `favouritename`,`users`.`name` AS `username`,`v_plugs_variables`.`id` AS `id`,`v_plugs_variables`.`name` AS `name`,`v_plugs_variables`.`type` AS `type`,`v_plugs_variables`.`communicateid` AS `communicateid`,`v_plugs_variables`.`variabletype` AS `variabletype`,`v_plugs_variables`.`readonly` AS `readonly`,`v_plugs_variables`.`min` AS `min`,`v_plugs_variables`.`max` AS `max`,`v_plugs_variables`.`prefix` AS `prefix`,`v_plugs_variables`.`suffix` AS `suffix`,`v_plugs_variables`.`categoryid` AS `categoryid`,`v_plugs_variables`.`category` AS `category`,`v_plugs_variables`.`mainlevelid` AS `mainlevelid`,`v_plugs_variables`.`level` AS `level` from (((`favouriteslist` left join `v_plugs_variables` on((`v_plugs_variables`.`name` = convert(`favouriteslist`.`name` using utf8mb4)))) left join `favourites` on((`favouriteslist`.`favouriteid` = `favourites`.`id`))) left join `users` on((`favourites`.`userid` = `users`.`id`))) */;
/*!50001 SET character_set_client      = @saved_cs_client */;
/*!50001 SET character_set_results     = @saved_cs_results */;
/*!50001 SET collation_connection      = @saved_col_connection */;

--
-- Final view structure for view `v_levels`
--

/*!50001 DROP TABLE IF EXISTS `v_levels`*/;
/*!50001 DROP VIEW IF EXISTS `v_levels`*/;
/*!50001 SET @saved_cs_client          = @@character_set_client */;
/*!50001 SET @saved_cs_results         = @@character_set_results */;
/*!50001 SET @saved_col_connection     = @@collation_connection */;
/*!50001 SET character_set_client      = utf8mb4 */;
/*!50001 SET character_set_results     = utf8mb4 */;
/*!50001 SET collation_connection      = utf8mb4_general_ci */;
/*!50001 CREATE ALGORITHM=UNDEFINED */
/*!50013 DEFINER=`root`@`localhost` SQL SECURITY DEFINER */
/*!50001 VIEW `v_levels` AS select `l`.`id` AS `id`,`l`.`mainid` AS `mainid`,`l`.`name` AS `name`,(select count(`levels`.`id`) from `levels` where (`levels`.`mainid` = `l`.`id`)) AS `sublevels` from `levels` `l` */;
/*!50001 SET character_set_client      = @saved_cs_client */;
/*!50001 SET character_set_results     = @saved_cs_results */;
/*!50001 SET collation_connection      = @saved_col_connection */;

--
-- Final view structure for view `v_plugs`
--

/*!50001 DROP TABLE IF EXISTS `v_plugs`*/;
/*!50001 DROP VIEW IF EXISTS `v_plugs`*/;
/*!50001 SET @saved_cs_client          = @@character_set_client */;
/*!50001 SET @saved_cs_results         = @@character_set_results */;
/*!50001 SET @saved_col_connection     = @@collation_connection */;
/*!50001 SET character_set_client      = utf8 */;
/*!50001 SET character_set_results     = utf8 */;
/*!50001 SET collation_connection      = utf8_general_ci */;
/*!50001 CREATE ALGORITHM=UNDEFINED */
/*!50013 DEFINER=`root`@`localhost` SQL SECURITY DEFINER */
/*!50001 VIEW `v_plugs` AS select `items`.`id` AS `id`,`items`.`name` AS `name`,`modules`.`moduleid` AS `moduleid`,`items`.`plugid` AS `plugid`,concat(`modules`.`moduleid`,'.',`plugtypes`.`name`,'#',convert(convert(lpad(`items`.`plugid`,2,'0') using latin1) using utf8mb4)) AS `communicateid`,`items`.`variabletype` AS `variabletype`,`items`.`readonly` AS `readonly`,`plugtypes`.`name` AS `plugtype`,`items`.`min` AS `min`,`items`.`max` AS `max`,`items`.`refreshtime` AS `refreshtime`,`items`.`prefix` AS `prefix`,`items`.`suffix` AS `suffix`,`items`.`categoryid` AS `categoryid`,`categories`.`name` AS `category`,`items`.`mainlevelid` AS `mainlevelid`,`items`.`name` AS `level`,`items`.`logtime` AS `logtime`,`items`.`correction` AS `correction`,`items`.`format` AS `format` from ((((`items` left join `modules` on((`items`.`moduleid` = `modules`.`id`))) left join `categories` on((`items`.`categoryid` = `categories`.`id`))) left join `levels` on((`items`.`mainlevelid` = `levels`.`id`))) left join `plugtypes` on(((`items`.`variabletype` = `plugtypes`.`variabletype`) and (`items`.`readonly` = `plugtypes`.`readonly`)))) where (`items`.`type` = 'plug') */;
/*!50001 SET character_set_client      = @saved_cs_client */;
/*!50001 SET character_set_results     = @saved_cs_results */;
/*!50001 SET collation_connection      = @saved_col_connection */;

--
-- Final view structure for view `v_plugs_variables`
--

/*!50001 DROP TABLE IF EXISTS `v_plugs_variables`*/;
/*!50001 DROP VIEW IF EXISTS `v_plugs_variables`*/;
/*!50001 SET @saved_cs_client          = @@character_set_client */;
/*!50001 SET @saved_cs_results         = @@character_set_results */;
/*!50001 SET @saved_col_connection     = @@collation_connection */;
/*!50001 SET character_set_client      = utf8 */;
/*!50001 SET character_set_results     = utf8 */;
/*!50001 SET collation_connection      = utf8_general_ci */;
/*!50001 CREATE ALGORITHM=UNDEFINED */
/*!50013 DEFINER=`root`@`localhost` SQL SECURITY DEFINER */
/*!50001 VIEW `v_plugs_variables` AS select concat('p_',`v_plugs`.`id`) AS `id`,`v_plugs`.`name` AS `name`,'plug' AS `type`,`v_plugs`.`communicateid` AS `communicateid`,`v_plugs`.`id` AS `tableid`,`v_plugs`.`variabletype` AS `variabletype`,`v_plugs`.`readonly` AS `readonly`,`v_plugs`.`min` AS `min`,`v_plugs`.`max` AS `max`,`v_plugs`.`prefix` AS `prefix`,`v_plugs`.`suffix` AS `suffix`,`v_plugs`.`categoryid` AS `categoryid`,`v_plugs`.`category` AS `category`,`v_plugs`.`mainlevelid` AS `mainlevelid`,`v_plugs`.`level` AS `level`,`v_plugs`.`logtime` AS `logtime` from `v_plugs` union select concat('v_',`v_variables`.`id`) AS `id`,`v_variables`.`name` AS `name`,'variable' AS `type`,`v_variables`.`communicateid` AS `communicateid`,`v_variables`.`id` AS `tableid`,`v_variables`.`variabletype` AS `variabletype`,`v_variables`.`readonly` AS `readonly`,`v_variables`.`min` AS `min`,`v_variables`.`max` AS `max`,`v_variables`.`prefix` AS `prefix`,`v_variables`.`suffix` AS `suffix`,`v_variables`.`categoryid` AS `categoryid`,`v_variables`.`category` AS `category`,`v_variables`.`mainlevelid` AS `mainlevelid`,`v_variables`.`level` AS `level`,`v_variables`.`logtime` AS `logtime` from `v_variables` */;
/*!50001 SET character_set_client      = @saved_cs_client */;
/*!50001 SET character_set_results     = @saved_cs_results */;
/*!50001 SET collation_connection      = @saved_col_connection */;

--
-- Final view structure for view `v_variables`
--

/*!50001 DROP TABLE IF EXISTS `v_variables`*/;
/*!50001 DROP VIEW IF EXISTS `v_variables`*/;
/*!50001 SET @saved_cs_client          = @@character_set_client */;
/*!50001 SET @saved_cs_results         = @@character_set_results */;
/*!50001 SET @saved_col_connection     = @@collation_connection */;
/*!50001 SET character_set_client      = utf8 */;
/*!50001 SET character_set_results     = utf8 */;
/*!50001 SET collation_connection      = utf8_general_ci */;
/*!50001 CREATE ALGORITHM=UNDEFINED */
/*!50013 DEFINER=`root`@`localhost` SQL SECURITY DEFINER */
/*!50001 VIEW `v_variables` AS select `items`.`id` AS `id`,`items`.`name` AS `name`,concat('variable.',`items`.`name`) AS `communicateid`,`items`.`variabletype` AS `variabletype`,`items`.`readonly` AS `readonly`,`items`.`min` AS `min`,`items`.`max` AS `max`,`items`.`prefix` AS `prefix`,`items`.`suffix` AS `suffix`,`items`.`categoryid` AS `categoryid`,`categories`.`name` AS `category`,`items`.`mainlevelid` AS `mainlevelid`,`items`.`name` AS `level`,`items`.`logtime` AS `logtime`,`items`.`startvalue` AS `startvalue`,`items`.`format` AS `format` from ((`items` left join `categories` on((`items`.`categoryid` = `categories`.`id`))) left join `levels` on((`items`.`mainlevelid` = `levels`.`id`))) where (`items`.`type` = 'variable') */;
/*!50001 SET character_set_client      = @saved_cs_client */;
/*!50001 SET character_set_results     = @saved_cs_results */;
/*!50001 SET collation_connection      = @saved_col_connection */;
/*!40103 SET TIME_ZONE=@OLD_TIME_ZONE */;

/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;

-- Dump completed on 2016-12-29 11:40:44
