(function( $ ){
  var methods = {
    init : function( options ) {
   
        return this.each(function(){
            var therm = new ThermometerGuage( $(this)[0], options );
            $(this).data('therm', therm);
        });    
       
    },
	setUnit : function(value) { 
        return this.each(function(){
            var therm = $(this).data('therm');
            if (therm != null) {        
                therm.setUnit(value);
            }
        });
    },
    setValue : function( value, value2 ) {
        return this.each(function(){
            var therm = $(this).data('therm');
            if (therm != null) {        
                therm.setValue( value, value2 );
            }
        });
    } 
  };

  $.fn.thermometer = function( method ) {
   
    // Method calling logic
    if ( methods[method] ) {
      return methods[ method ].apply( this, Array.prototype.slice.call( arguments, 1 ));
    } else if ( typeof method === 'object' || ! method ) {
      return methods.init.apply( this, arguments );
    } else {
      $.error( 'Method ' +  method + ' does not exist on jQuery.thermometer' );
    }    
 
  };
})( jQuery );
