(function( $ ){

    var methods = {
        init : function( options ) 
		{
			return this.each(function()
			{
				var komp = new kompassfunction( $(this)[0], options );
				$(this).data('komp', komp);
			});     
		},
		setValues : function(direction, speed) {
			return this.each(function(){
				var komp = $(this).data('komp');
				if (komp != null) {			
					komp.setValue(direction, speed );
				}
			});
		},
        show : function( ) {    },// IS
        hide : function( ) {  },// GOOD
        update : function( content ) {  }// !!!
    };

    $.fn.kompass = function(methodOrOptions) {
        if ( methods[methodOrOptions] ) {
            return methods[ methodOrOptions ].apply( this, Array.prototype.slice.call( arguments, 1 ));
        } else if ( typeof methodOrOptions === 'object' || ! methodOrOptions ) {
            // Default to "init"
            return methods.init.apply( this, arguments );
        } else {
            $.error( 'Method ' +  methodOrOptions + ' does not exist on jQuery.kompass' );
        }    
    };
})( jQuery );

function kompassfunction(canvas, options) {
    var that = this;
    this.ctx = canvas.getContext('2d');
    this.settings = {
        w: canvas.width,
        h: canvas.height,
		color: {},
		font: {}
	};
	
	function setOptions(options)
	{
        var _ = that.settings;
		options.color = options.color || {};
		options.font = options.font || {};
        //jQuery.extend(true, that.settings, options);  //the easy way, but depends on jQuery, so here's the hard way ;-(  ...
            _.w					=	options.w				|| _.w;
            _.h					=	options.h				|| _.h;
            _.ctx				=	options.ctx				|| _.ctx;
            _.radius			=	options.radius			|| _.radius				||  10;
			_.direction			=	options.direction		|| _.direction			||	0;
			_.speed				=	options.speed			|| _.speed				||	0;
			_.min				=	options.min				|| _.min				||	0;
			_.max				=	options.max				|| _.max				||	20;
			_.unit				=	options.unit			|| _.unit				||	"m/s";
			_.lang				=	options.lang			|| _.lang				||	"Deutsch";
			_.label_ticks		=	options.label_ticks		|| _.lable_ticks		||	2;
			_.divisionCount		=	options.divisionCount	|| _.divisionCount		||	16;
			_.font.main			=	options.font.main		|| _.font.main			||	18;
			_.font.sub			=	options.font.sub		|| _.font.sub			||	13;
			_.font.subsub		=	options.font.subsub		|| _.font.subsub		||	10;
			_.font.count		=	options.font.count		|| _.font.count			||	3;
			_.color.circle		=	options.color.circle	|| _.color.circle		||	'#707070 ';
			_.color.line		=	options.color.line		|| _.color.line			||	'#707070 ';
			_.color.fill		=	options.color.fill		|| _.color.fill			||	'#ffffff';
			_.color.font		=	options.color.font		|| _.color.font			||	'#ffffff';			
    };
	
	function setValue(direction, speed)
	{
        that.settings.w = $(canvas).width();
        that.settings.h = $(canvas).height();
        that.ctx.canvas.width = that.settings.w;
        that.ctx.canvas.height = that.settings.h;
		var min = that.settings.min;
		var max = that.settings.max;
		if (direction > 0)
		{
			direction = direction * Math.PI / 180;
		}
		else
		{
			direction = -direction * Math.PI / 180;
		}
		that.settings.direction = direction;
		min = speed < min ? parseInt(speed-2) : min;
		min = min < 0 ? 0 : min;
		max = speed > min ? parseInt(speed+2) : max;
		that.settings.speed = speed;
		checkDivisionCount();
		clearCanvas();
		drawKompass();
		drawSpeed();
    };
	
	function clearCanvas()
	{
		that.ctx.clearRect(0, 0, that.settings.w, that.settings.h);
	};
	
	function checkDivisionCount()
	{
		var divisionCount = that.settings.divisionCount;
		if (divisionCount != 4 && divisionCount != 8 && divisionCount != 16)
		{
			that.settings.divisionCount = 4;
		}
	}
	
	function drawKompass()
	{
		var directions = new Array("N", "NNO", "NO", "ONO", "O", "OSO", "SO", "SSO", "S", "SSW", "SW", "WSW", "W", "WNW", "NW", "NNW");
		if(that.settings.lang != "Deutsch")
		{
			directions = new Array("N", "NNE", "NE", "ENE", "E", "ESE", "SE", "SSE", "S", "SSW", "SW", "WSW", "W", "WNW", "NW", "NNW");
		}
		var w = that.settings.w;
		var h = that.settings.h;
		var radius = that.settings.radius;
		var circle= that.settings.color.circle;
		var line_stroke=  that.settings.color.line;
		var c_font= that.settings.color.font;
		var fill= that.settings.color.fill;
		var divisionCount = that.settings.divisionCount;
		var font = that.settings.font;
		var direction = that.settings.direction;
		that.ctx.translate(0.5, 0.5);
		that.ctx.lineWidth = 1;
		var MP = {x: w/2, y: radius+20+font.main/2};
		
		var angles = getLineAngle(divisionCount);
		
		//Draw Circles
		that.ctx.strokeStyle = circle;
		that.ctx.lineWidth = 1;
		
		that.ctx.beginPath();
		that.ctx.arc(MP.x, MP.y,radius,0,2*Math.PI);
		that.ctx.fillStyle = fill;
		that.ctx.fill();
		that.ctx.closePath();
		that.ctx.stroke();
		
		that.ctx.beginPath();
		that.ctx.arc(MP.x, MP.y,radius*2/3,0,2*Math.PI);
		that.ctx.closePath();
		that.ctx.stroke();
		
		that.ctx.beginPath();
		that.ctx.arc(MP.x, MP.y,radius/3,0,2*Math.PI);
		that.ctx.closePath();
		that.ctx.stroke();
		
		that.ctx.lineWidth = 0.5;
		for (var i = 0; i < angles.length/2; i++)
		{
			//Draw Lines
			var line = getPoint(MP, radius, angles[i]);
			that.ctx.strokeStyle = line_stroke;
			that.ctx.beginPath();
			that.ctx.moveTo(line.from.x, line.from.y);
            that.ctx.lineTo(line.to.x, line.to.y);
			that.ctx.closePath();
			that.ctx.stroke();
			//Draw Fonts
			that.ctx.fillStyle = c_font;
			var fontpoints = getPoint(MP, radius + 20, angles[i]);
			that.ctx.textAlign="center";
			that.ctx.textBaseline="middle";
			
			var drawfont = false;
			if(i==0 || i%4 == 0 && font.count > 0)
			{
				that.ctx.font= font.main + "px Arial";
				drawfont = true;
			}
			else if((i+2)%4 == 0 && font.count > 1)
			{
				that.ctx.font= font.sub + "px Arial";
				drawfont = true;
			}
			else if((i+1)%2 == 0 && font.count > 2)
			{
				that.ctx.font= font.subsub + "px Arial";
				drawfont = true;
			}
			if(drawfont)
			{
				that.ctx.fillText(directions[i],fontpoints.from.x,fontpoints.from.y);
				that.ctx.fillText(directions[i+divisionCount/2],fontpoints.to.x,fontpoints.to.y);
				that.ctx.stroke();
			}
        }
		

		
		//DrawNeedle
		var a = 30;
		var b = radius+10;
		var c = radius/7*3;
		that.ctx = drawTriangle(that.ctx, MP, a, b, direction, '#E00000', '#A00000');
		that.ctx = drawTriangle(that.ctx, MP, a, -b, direction, '#A0A0A0', '#383838');
		that.ctx = drawTriangle(that.ctx, MP, a, -c, direction, '#E00000', '#A00000');
		var line = getPoint(MP, radius, direction*180/Math.PI);
		that.ctx.moveTo(line.from.x, line.from.y);
		that.ctx.lineTo(line.to.x, line.to.y);
		that.ctx.stroke();
		
		//DrawMiddlePoint
		that.ctx.beginPath();
		that.ctx.arc(MP.x, MP.y,6,0,2*Math.PI);
		that.ctx.fillStyle = '#000000';
		that.ctx.fill();
	};
	
	function drawTriangle(ctx, MP, a ,b,phi,color1, color2)
	{
		/*p1 = {x: MP.x - a/2 * Math.cos(phi), y: MP.y - a/2 * Math.sin(phi)};
		p2 = {x: MP.x + a/2 * Math.cos(phi), y: MP.y + a/2 * Math.sin(phi)};
		p3 = {x: MP.x + b * Math.sin(phi), y: MP.y - b * Math.cos(phi)};
		ctx.beginPath();
		ctx.moveTo(p1.x, p1.y);
        ctx.lineTo(p2.x, p2.y);
		ctx.lineTo(p3.x, p3.y);
		ctx.lineTo(p1.x, p1.y);
		ctx.closePath();
		var my_gradient= ctx.createLinearGradient(p1.x,p1.y,p2.x,p2.y);
		my_gradient.addColorStop(0,color1);
		my_gradient.addColorStop(1,color2);
		ctx.fillStyle = my_gradient;
		ctx.fill();
		ctx.stroke();
		return ctx;*/
		p1 = {x: MP.x - a/2 * Math.cos(phi), y: MP.y - a/2 * Math.sin(phi)};
		p2 = {x: MP.x + a/2 * Math.cos(phi), y: MP.y + a/2 * Math.sin(phi)};
		p3 = {x: MP.x + b * Math.sin(phi), y: MP.y - b * Math.cos(phi)};
		ctx.beginPath();
		ctx.moveTo(p1.x, p1.y);
        ctx.lineTo(MP.x, MP.y);
		ctx.lineTo(p3.x, p3.y);
		ctx.lineTo(p1.x, p1.y);
		ctx.closePath();
		ctx.fillStyle = color1;
		ctx.fill();
		ctx.stroke();
		ctx.beginPath();
		ctx.moveTo(p2.x, p2.y);
        ctx.lineTo(MP.x, MP.y);
		ctx.lineTo(p3.x, p3.y);
		ctx.lineTo(p2.x, p2.y);
		ctx.closePath();
		ctx.fillStyle = color2;
		ctx.fill();
		ctx.stroke();
		return ctx;
	};
	
	function getLineAngle(count)
	{
		var myAngles = new Array();
		for (i=0; i<count; i++)
		{
			myAngles[i] = 360/count*i;
		}
		return myAngles;
	};
	
	function getPoint(MP, r, phi)
	{
		phi = phi / 180 * Math.PI;
		var from 	= {x: MP.x + r*Math.sin(phi), y: MP.y - r*Math.cos(phi)};
		var to		= {x: MP.x - r*Math.sin(phi), y: MP.y + r*Math.cos(phi)};
		return {from: from, to: to};
	};
	
	function drawSpeed()
	{
		var w = that.settings.w;
		var h = that.settings.h;

		//DrawRectangle
		var rectheight = 30;
		var spaceSide = 20;
		var StartPoint = {x: spaceSide,y:h-rectheight};
		that.ctx.beginPath();
		that.ctx.rect(StartPoint.x,StartPoint.y,w - 2*spaceSide,rectheight);
		that.ctx.closePath();
		that.ctx.strokeStyle = '#000000';
		that.ctx.stroke();
		var my_gradient=that.ctx.createLinearGradient(StartPoint.x,StartPoint.y,StartPoint.x + w,StartPoint.y);
		my_gradient.addColorStop(0,'#00FF33');
		my_gradient.addColorStop(0.5,'#FF6600');
		my_gradient.addColorStop(1,'#FF0000');
		that.ctx.fillStyle = my_gradient;
		that.ctx.fill();

		var min = that.settings.min;
		var max = that.settings.max;
		var speed = that.settings.speed;
		
		//DrawTicks
		that.ctx.strokeStyle = that.settings.color.line;
		var label_ticks = that.settings.label_ticks;
		var font = that.settings.font;
		that.ctx.lineWidth = 1
		for (i = 1; min + i*label_ticks < max; i++)
		{
			
			that.ctx.beginPath();
			var tick = {x:StartPoint.x + (w-2*spaceSide)/(max-min)*(i*label_ticks),y:h-rectheight};
			that.ctx.moveTo(tick.x, tick.y);
			that.ctx.lineTo(tick.x, tick.y+h);

			that.ctx.closePath();
			that.ctx.stroke();
			
			that.ctx.font= font.subsub + "px Arial";
			that.ctx.textBaseline="bottom"; 
			that.ctx.fillStyle = that.settings.color.font;
			that.ctx.textAlign="center";
			that.ctx.fillText(min + i*label_ticks,tick.x, tick.y);
			that.ctx.stroke();
		}
		
				
		//DrawSpeed
		that.ctx.beginPath();
		that.ctx.lineWidth = 2;
		var SpeedPoint = {x:StartPoint.x + (w-2*spaceSide)/(max-min)*(speed-min),y:h-rectheight};
		that.ctx.strokeStyle = '#000000';
		that.ctx.moveTo(SpeedPoint.x, SpeedPoint.y);
		that.ctx.lineTo(SpeedPoint.x, SpeedPoint.y+h);
		that.ctx.closePath();
		that.ctx.stroke();
		
		
		//DrawLabels
		
		that.ctx.font= font.sub + "px Arial";
		that.ctx.textBaseline="bottom"; 
		that.ctx.fillStyle = that.settings.color.font;
		
		that.ctx.fillText(min,StartPoint.x,StartPoint.y);
		that.ctx.stroke();

		that.ctx.fillText(max,w-spaceSide,StartPoint.y);
		that.ctx.stroke();
		
		that.ctx.fillStyle = '#000000';
		that.ctx.fillText(speed + that.settings.unit,SpeedPoint.x,SpeedPoint.y-rectheight/2);
		that.ctx.stroke();
	};
	
	this.setupOptions = setOptions;
    this.setupOptions(options);
	
	this.setValue = setValue;
    
    return this;
}