app.controller("overviewSettingsController", function($scope, $http, $rootScope, $q) 
{
    $scope.overviewData = {};
    $scope.config = {};
    $scope.display = "";
    $scope.removed = [];
    $scope.allItems = function(){return $rootScope.allItems};
    
    $scope.updatePluginTemplate = function()
    {
        return $q(function (resolve, reject) 
        {
            $http.get("plugins/" + $scope.display + "_template.json").then(function (response) 
            {
                $scope.template = response.data;
                resolve();
            }); 
        });
    };
    
    $scope.sendValue = function(communicateid)
    {
        SendValue(communicateid);
    };
    
    $scope.removeItem = function(config)
    {
        if(config.id != -1)
        {
            $scope.removed.push(config.id);
        }
        
        var index = $scope.overviewData.indexOf(config);

        if (index > -1) {
            $scope.overviewData.splice(index, 1);
        }
        
    }
    
    $scope.save = function()
    {
        var saveOverviewData = [];
        
        for(var i in  $scope.overviewData)
        {
            x = $scope.overviewData[i];
            saveOverviewData.push({id: x.id, x: x.x, y: x.y, widht: x.width, height: x.height});
        }
        
        $.ajax(
        {
            type: "POST",
            url: "php/settings/overview/save_overview_layout.php",
            data: 
            {
                removed: $scope.removed,
                config: $scope.overviewData
            }
        })
          .done(function( data ) {
              reloadPage();
        });
    }
    
    $scope.template = [];
    $scope.value = {};
    
    $http.get("php/main/ajax/overview_data.php").then(function (response) 
    {
        $scope.overviewData = response.data;
        for(var i in $scope.overviewData)
        {
            $scope.overviewData[i].json = JSON.parse($scope.overviewData[i].json);
        }
    });
    
    $scope.openDialogAndSetID = function(config)
    {
        if(config.id == -1)
        {
            alert("Save the layout before you can continue.");
            return;
        }
        $scope.display = config.display
        $scope.config = config;
        $scope.value = {};
        $scope.updatePluginTemplate().then(function(result)
        {
            var copiedObject = jQuery.extend(true, {}, $scope.config)
            for(var i in $scope.template)
            {
                if($scope.template[i].id !== undefined)
                {
                    $scope.value[$scope.template[i].id] = copiedObject.json[$scope.template[i].id];
                    
                    if($scope.template[i].type == "item")
                    {
                        $scope.value[$scope.template[i].id] = $scope.config.json[$scope.template[i].id];
                    }
                    else if($scope.template[i].type == "multiitem")
                    {
                        $scope.value[$scope.template[i].id] = [];
                        for(var j in $scope.config.json[$scope.template[i].id])
                        {
                            $scope.value[$scope.template[i].id].push($scope.allItems()[$scope.config.json[$scope.template[i].id][j].communicateid]);
                        }
                    }
                }
            }
        });   
        
            
        openDialog('overview_dialog');
    };
    
    $scope.setSaveOrDefault = function(obj)
    {
        if($scope.value[obj.id] === undefined)
        {
            $scope.value[obj.id] = obj["default"];
        }
    }
    
    $scope.setVariable = function(object, name)
    {
        return $q(function (resolve, reject) 
        {
            if(name === undefined)
            {
                return;
            }
            $rootScope.allItemsParsed.then(function(result) 
            {
                var allItems = $scope.allItems();
                for(var i in allItems)
                {
                    if(allItems[i].name == object[name])
                    {
                        object[name] = allItems[i];
                        resolve(name);
                        break;
                    }
                }
                
            });
        });

    };
    
    $scope.addField = function()
    {
        $scope.overviewData.push({x:0, y:0, width:100, height: 100, id:-1});
    }
    
    
    
    $scope.configOk = function(form)
    {
        if(!form.$valid) 
        {
           return;
        }
        var copiedObject = jQuery.extend(true, {}, $scope.value)

        for(var i in $scope.template)
        {
            if($scope.template[i].type == "item" || $scope.template[i].type == "multiitem")
            {

                if(copiedObject[$scope.template[i].id] !== undefined)
                {
                    if($scope.template[i].type == "multiitem")
                    {
                        for(var j in copiedObject[$scope.template[i].id])
                        {
                            copiedObject[$scope.template[i].id][j] = copiedObject[$scope.template[i].id][j].name;
                        }
                    }
                    else
                    {
                        copiedObject[$scope.template[i].id] = copiedObject[$scope.template[i].id].name;
                    }
                }
                else
                {
                    copiedObject[$scope.template[i].id] = "";
                }
            }
        }

        
        insertConfig = function()
        {
            $.ajax(
            {
                type: "POST",
                url: "php/settings/overview/save_overview_content.php",
                data: 
                {
                    id: $scope.config.id,
                    display: $scope.display,
                    json: JSON.stringify(copiedObject)
                }
            })
          .done(function( data ) {
            alert(data);
            reloadPage();
          });
        }
        
        insertConfig();
        
    }
});