var app = angular.module('myApp', [])
.run(function($rootScope, $http) {
    $rootScope.allItems = {};
    extScope = $rootScope;
    
    $rootScope.allItemsParsed = $http.get("php/main/ajax/plugsandvariables.php").then(function (response) 
    {
        $rootScope.allItems = {};
                    
        var Variables = [];
        for(var i in response.data)
        {
            $rootScope.allItems[response.data[i].communicateid] = response.data[i];
            response.data[i].favourite = "false";
            response.data[i].setValue = function(value)
            {
                if(this.variabletype == "Int32")
                {
                    this.value = parseInt(value);
                }
                else if(this.variabletype == "Double")
                {
                    this.value = parseFloat(value);
                }
                else if(this.variabletype == "DateTime" || this.variabletype == "Time")
                {
                    //this.value = new Date(value);
                    this.value = value;
                }
                else
                {
                    this.value = value;
                }
            };
            response.data[i].setValue("0");
            Variables.push(response.data[i].communicateid);
        }
        
        RequestStatus(Variables);
    });
    
})

app.controller('overviewController', function($scope, $http, $compile) 
{       
    $http.get("php/main/ajax/categories.php").then(function (response) 
    {
        $scope.categories = response.data;  
        $scope.changeDisplay($scope.display);
    });
    $http.get("php/main/ajax/levels.php").then(function (response) 
    {
        $scope.levels = response.data;
        $scope.changeDisplay($scope.display);
    });
    
    
    $scope.loadFavourites = function()
    {
        $http.get("php/main/ajax/favourites.php").then(function (response) 
        {
            $scope.favourites = response.data;
            $scope.changeDisplay($scope.display);
        }); 
    }
    
    $scope.loadFavourites();
    

    $scope.setFavourite = function(id)
    {
        if(id == undefined)
        {
            if($scope.favourites != undefined && $scope.favourites.length != 0 && $scope.favourites[0].favouriteid != undefined)                 
            {
                id = $scope.favourites[0].favouriteid;
            }
            else
            {
                return;
            }
        }
        $scope.show.favourite = id;
        $scope.show.edit = "";
        var currentFavourite = $scope.getCurrentFavourite();

        for(var i in $scope.allItems)
        {
            $scope.allItems[i].favourite = "false";
            for(var j in currentFavourite)
            {
                if(currentFavourite[j].name == $scope.allItems[i].name )
                {
                    $scope.allItems[i].favourite = "true";
                    break;
                }
            }
        }
        $scope.show.favouritefilter = "true";
    }
    
    
    $scope.option = "";
    $scope.show = 
    {
        type: "",
        category: "",
        level: "",
        favourite: "",
        favouritefilter: "",
        edit: ""
    };

    $scope.changeDisplay = function(type)
    {
        $scope.display = type;
        $scope.show.type = "";
        $scope.show.category = "";
        $scope.show.level = "";
        $scope.show.favourite = "";
        $scope.show.edit = "";
        $scope.show.favouritefilter = "";

        if(type == "category" && $scope.categories != undefined && $scope.categories.length != 0)
        {
            $scope.show.category = $scope.categories[0].id;
        }
        else if(type == "level" && $scope.levels != undefined && $scope.levels.length != 0)
        {
            $scope.show.level = $scope.levels[0].id;
        }
        else if(type == "favourite")
        {
            $scope.setFavourite();
        }
        else
        {
            if(!(type == "category" || type == "level" || type == "favourite"))
            {
                $scope.display = "all";
            }
        }
    };
    
    $scope.display = "all";
    
    $scope.getCurrentFavourite = function()
    {
        var out = [];
        for(var i in $scope.favourites)
        {
            if( $scope.favourites[i].favouriteid == $scope.show.favourite)
            {
                out.push($scope.favourites[i]);
            }
        }
        return out;
    }
            
    $scope.currentLevel = function()
    {
        for(var i in $scope.levels)
        {
            if($scope.levels[i].id == $scope.show.level)
            {
                return $scope.levels[i];
            }
        }
        return undefined;
    };
    
    $scope.plugClick = function(communicateid)
    {
        PlugClick(communicateid);
    };
    
    $scope.sendValue = function(communicateid)
    {
        SendValue(communicateid);
    };
    
    $scope.setEdit = function(id)
    {
        $scope.show.favourite = id;
        $scope.show.favouritefilter = "";
        $scope.show.edit = "edit";
    };
                
    $scope.toggleFavourite = function(Item)
    {
        Item.favourite = Item.favourite == "true" ? "false" : "true";
    };
    
    $scope.saveFavourites = function()
    {
        var dataObj = {};
        dataObj.id = $scope.show.favourite;
        dataObj.favourites = [];
        
        
        for(var i in $scope.allItems)
        {
            if($scope.allItems[i].favourite == "true")
            {
                dataObj.favourites.push($scope.allItems[i].name);
            }
        }
        
        $.post('php/status/overview/post_savefavourites.php', dataObj ,function(data)
        {
            $scope.loadFavourites();
        });
    };
    
    var hash = window.location.hash;
    var params = {};
    if(hash.indexOf('?') > 0)
    {
        var values = hash.split('?')[1].split('&');
        for(var i in values)
        {
           params[values[i].split('=')[0]] = values[i].split('=')[1];
        }
    }
        
    if(params["view"] != "all")
    {
        $scope.changeDisplay(params["view"]);
    }
    
    
    
});


app.filter('strictorall', function () 
{
    return function (input, itemType) 
    {
        var out = [];
        if(input != undefined)
        {
            var all = true;
            for(var i in itemType)
            {
                if(itemType[i] != "")
                {
                   all = false;
                }
            }
            if(all)
            {
                return input;
            }
            for(var i in input)
            {
                for(var j in itemType)
                {
                    if(input[i][j] == itemType[j])
                    {
                        out.push(input[i]);
                    }
                }
            }
        }

        return out;
    }
 });
 
 app.filter('inArray', function () 
{
    return function (input, itemType) 
    {
        var out = [];

        for(var i in itemType)
        {
            if(itemType[i] === undefined)
            {
                return input;
            }
        }
        

        if(input != undefined)
        {
            for(var i in input)
            {
                for(var j in itemType)
                {
                    for(var k in itemType[j])
                    {
                        if(input[i][j] ==itemType[j][k])
                        {
                            out.push(input[i]);
                            break;
                        }                       
                    }
                }
            }
        }

        return out;
    }
 });
 
app.filter('unique', function () 
{
    return function (input, itemType) 
    {
        var out = [];
        if(input != undefined)
        {
            for(var i in input)
            {
                var in_array = false;
                for(var j in out)
                {
                    if(out[j][itemType] == input[i][itemType])
                    {
                        in_array = true;
                        break;
                    }
                }
                if(!in_array)
                {
                    out.push(input[i]);
                }
                
            }
        }

        return out;
    }
});