function ThermometerGuage(canvas, options) {
    var that = this;
    this.ctx = canvas.getContext('2d');
    this.settings = {
        w: canvas.width,
        h: canvas.height,
        ctx: this.ctx,
        color: {}
    };



    function setValue(val,val2) 
    {
        that.settings.w = $(canvas).width();
        that.settings.h = $(canvas).height();
        that.settings.ctx.canvas.width = that.settings.w;
        that.settings.ctx.canvas.height = that.settings.h;
		var max = that.settings.max;
        var min = that.settings.min;
		
        that.settings.fillToInput = val;
        if (val > max) 
          that.settings.fillTo = 1;
        else if (val < min) 
          that.settings.fillTo = 0;
        else
          that.settings.fillTo = ((val - min) / (max - min));

        clearCanvas();
        drawThermometerContainer();
        drawLabel(val, val2);
		fill();
		drawTicks();
    };
    
    function setUnit(value) 
    {
        that.settings.Unit = value;
    };


    function clearCanvas() {
		that.ctx.clearRect(0, 0, that.settings.w, that.settings.h);
    };

    function setOptions(options) {
        var _ = that.settings;
            options.color = options.color || {};
            _.w                     =  options.w                    || _.w;
            _.h                     =  options.h                    || _.h;
            _.ctx                   =  options.ctx                  || _.ctx;
            _.max                   =  options.max                  || _.max                    ||  1;
            _.min                   =  options.min                  || _.min                    ||  0;
            _.gradient              =  options.gradient             || _.gradient               ||  false;
            _.color.fill            =  options.color.fill           || _.color.fill             ||  '#ff0000';
            _.color.fill1           =  options.color.fill1         	|| _.color.fill1            ||  '#610B0B';
            _.color.label           =  options.color.label          || _.color.label            ||  'rgba(45, 45, 45, 1)';
            _.color.outline         =  options.color.outline        || _.color.outline          ||  'rgba(0, 0, 0, 0.5)';
            _.color.outlineFill     =  options.color.outlineFill    || _.color.outlineFill      ||  '#ffffff';
            _.color.tick            =  options.color.tick           || _.color.tick             ||  'black';
            _.color.tickLabel       =  options.color.tickLabel      || _.color.tickLabel        ||  'rgba(45, 45, 45, 1)';
            _.outlineScale			=  options.outlineScale 		|| _.outlineScale  			||  1.3;
            _.majorTicks            =  options.majorTicks           || _.majorTicks             ||  0;
            _.minorTicks            =  options.minorTicks           || _.minorTicks             ||  0;
            _.minorTicksFont    	=  options.minorTicksFont   	|| _.minorTicksFont    	 	||  false;
			_.majorTicksSize		=  options.majorTicksSize		|| _.majorTicksSize			||	12;
            _.centerTicks           =  options.centerTicks          || _.centerTicks            ||  true;
			_.TickIncudingBlub     	=  options.TickIncudingBlub     || _.TickIncudingBlub       ||  false;
            _.scaleTickLabelText    =  options.scaleTickLabelText   || _.scaleTickLabelText     ||  1;
            _.scaleLabelText        =  options.scaleLabelText       || _.scaleLabelText         ||  1;
            _.scaleTickWidth        =  options.scaleTickWidth       || _.scaleTickWidth         ||  1;
			_.blubRadiusScale       =  options.blubRadiusScale      || _.blubRadiusScale        ||  1;
            _.Unit			        =  options.Unit					|| _.Unit             		||  "°C";
			_.UnitHeight			=  options.UnitHeight			|| _.UnitHeigt				||	14;
			_.pipeWidthPercentage	=  options.pipeWidthPercentage	|| _.pipeWidthPercentage	||	0.09;
			_.fillTo				=  options.fillTo				|| _.fillTo					||	0;
    };
	
	function drawThermometerContainer()
	{
		var h = that.settings.h;
		var w = that.settings.w;
		var outlinescale = that.settings.outlineScale ;
		var pipeWidth = h * that.settings.pipeWidthPercentage * outlinescale;
		var blubRadius = pipeWidth / 2 * that.settings.blubRadiusScale;
		var height = h - 2 * that.settings.UnitHeight - blubRadius ;
		var abstheight = 0.7 * blubRadius;
		var ctx = that.ctx;
		var BlubMP = {x: w/2, y: height};
		var blubStartAngel = - Math.asin(abstheight/blubRadius);
		var blubEndAngel = Math.PI - blubStartAngel;
		var TopRadius = blubRadius * Math.sin(-blubStartAngel);
		var TopMP = {x: BlubMP.x, y: TopRadius + that.settings.majorTicksSize/2};
		//OUTLINE
		that.ctx.lineWidth = 1;
		that.ctx.beginPath();
		ctx.arc(BlubMP.x,BlubMP.y, blubRadius, blubStartAngel, blubEndAngel);
		ctx.lineTo(TopMP.x - TopRadius, TopMP.y);
		ctx.arc(TopMP.x,TopMP.y, TopRadius, Math.PI, 2*Math.PI);		
		ctx.closePath();
		ctx.fillStyle = that.settings.color.outlineFill;
		ctx.fill();
		ctx.strokeStyle = that.settings.color.outline;
		ctx.stroke();
	};
	
	function fill(val)
	{	
		var h = that.settings.h;
		var w = that.settings.w;
		var pipeWidth = h * that.settings.pipeWidthPercentage;
		var outlinescale = that.settings.outlineScale;
		var blubRadius = pipeWidth / 2 * that.settings.blubRadiusScale;
		var height = h - 2 * that.settings.UnitHeight - blubRadius * outlinescale ;
		var abstheight = 0.7 * blubRadius;
		var ctx = that.ctx;
		var BlubMP = {x: w/2, y: height};
		var blubStartAngel = - Math.asin(abstheight/blubRadius);
		var blubEndAngel = Math.PI - blubStartAngel;
		var TopRadius = blubRadius * Math.sin(-blubStartAngel);
		var TopMP = {x: BlubMP.x, y: TopRadius*outlinescale + that.settings.majorTicksSize/2};
		
		//FILL
		that.ctx.lineWidth = 1;
		that.ctx.beginPath();
		if(that.settings.TickIncudingBlub)
		{
			var totalHeight = BlubMP.y - TopMP.y + blubRadius + TopRadius;
			var heightToDraw = totalHeight * that.settings.fillTo;
			
			if (heightToDraw < blubRadius)
			{
				blubStartAngel = - Math.asin(heightToDraw/blubRadius);
				blubEndAngel = Math.PI - blubStartAngel;
				ctx.arc(BlubMP.x,BlubMP.y, blubRadius, blubStartAngel, blubEndAngel);
			}
			else if (heightToDraw < totalHeight - TopRadius)
			{
				ctx.arc(BlubMP.x,BlubMP.y, blubRadius, blubStartAngel, blubEndAngel);
				ctx.lineTo(TopMP.x - TopRadius, BlubMP.y + blubRadius - heightToDraw);
				ctx.lineTo(TopMP.x + TopRadius, BlubMP.y + blubRadius - heightToDraw);
			}
			else
			{
				ctx.arc(BlubMP.x,BlubMP.y, blubRadius, blubStartAngel, blubEndAngel);
				ctx.lineTo(TopMP.x - TopRadius, TopMP.y);
				var x = (totalHeight * that.settings.fillTo-(totalHeight - TopRadius))/TopRadius;
				var phi = 0;
				x > 1 ? phi = Math.PI/2 : phi = Math.asin(x);
				ctx.arc(TopMP.x,TopMP.y, TopRadius, Math.PI, Math.PI + phi);
				ctx.lineTo(TopMP.x + TopRadius*Math.cos(phi), TopMP.y - TopRadius*Math.sin(phi));
				ctx.arc(TopMP.x,TopMP.y, TopRadius, - phi, 0);
			}

		}
		else
		{
			ctx.arc(BlubMP.x,BlubMP.y, blubRadius, blubStartAngel, blubEndAngel);
			var offset = 5;
			var fillHeight = TopMP.y + (BlubMP.y - TopMP.y - blubRadius - offset)*(1-that.settings.fillTo);
			ctx.lineTo(TopMP.x - TopRadius, fillHeight);
			ctx.lineTo(TopMP.x + TopRadius, fillHeight);
		}		
		ctx.closePath();
		var my_gradient= ctx.createLinearGradient(BlubMP.x - blubRadius,BlubMP.y,BlubMP.x + blubRadius,BlubMP.y);
		my_gradient.addColorStop(0,that.settings.color.fill);
		my_gradient.addColorStop(1,that.settings.color.fill1);
		ctx.fillStyle = my_gradient;
		ctx.fill();
	};
	
	function drawLabel(val, val2)
	{
                val = Math.round(val * 100) / 100;
                if(val2 != "")
                {
                   val2 = Math.round(val2 * 100) / 100;
                }
                if(isNaN(val2))
                {
                   val2=0;
                }
                var _ = that.settings;
                var ctx = that.ctx;
                var h = that.settings.h;
                var w = that.settings.w;
                ctx.fillStyle = _.color.label;
                ctx.textAlign="center";
                ctx.textBaseline="bottom";
                ctx.font = _.UnitHeight + "px Arial";
                ctx.fillText(val + _.Unit + " " + val2 + "%", w/2, h);
	};
	
	function drawTicks()
	{
		var h = that.settings.h;
		var w = that.settings.w;
		var pipeWidth = h * that.settings.pipeWidthPercentage;
		var outlinescale = that.settings.outlineScale;
		var blubRadius = pipeWidth / 2 * that.settings.blubRadiusScale;
		var height = h - 2 * that.settings.UnitHeight - blubRadius * outlinescale ;
		var abstheight = 0.7 * blubRadius;
		var ctx = that.ctx;
		var BlubMP = {x: w/2, y: height};
		var blubStartAngel = - Math.asin(abstheight/blubRadius);
		var blubEndAngel = Math.PI - blubStartAngel;
		var TopRadius = blubRadius * Math.sin(-blubStartAngel);
		var TopMP = {x: BlubMP.x, y: TopRadius*outlinescale + that.settings.majorTicksSize/2};
		var totalHeight = BlubMP.y - TopMP.y + blubRadius + TopRadius;
		var heightToDraw = totalHeight * that.settings.fillTo;
		
		var offset = 5;
		var startY = 0;
		that.settings.TickIncudingBlub ? startY = BlubMP.y + blubRadius : startY = BlubMP.y - abstheight - offset;
		var stopY = 0;
		that.settings.TickIncudingBlub ? stopY = TopMP.y - TopRadius  : stopY = TopMP.y;
		var min = that.settings.min;
		var max = that.settings.max
		var oneUnit = (startY - stopY)/(max-min);
		var MajorAbstY =  that.settings.majorTicks;
		var MajorWidth = pipeWidth * 0.6 * that.settings.scaleTickWidth;

		for (var i = 0; min + i * MajorAbstY <= max; i++)
		{
			that.ctx.lineWidth = 2;
			that.ctx.strokeStyle = that.settings.color.tick;
			that.ctx.beginPath();
			that.ctx.closePath();
			ctx.moveTo(TopMP.x - pipeWidth/2 - 2 ,startY - (i * MajorAbstY)*oneUnit);
			ctx.lineTo(TopMP.x - pipeWidth/2 - MajorWidth - 2, startY - (i * MajorAbstY)*oneUnit);
			that.ctx.stroke();

			ctx.fillStyle = that.settings.color.tick;
			ctx.textAlign="right";
			ctx.textBaseline="middle";
			ctx.font = that.settings.majorTicksSize + "px Arial";
			ctx.fillText(min+i * MajorAbstY, TopMP.x - pipeWidth - 10, startY - (i * MajorAbstY)*oneUnit);
		}
		
		
		var scaleFactor = 0.8;
		var MinorAbstY =  that.settings.minorTicks;
		var MinorWidth = MajorWidth * scaleFactor;
		

		for (var i = 0; min + i * MinorAbstY <= max; i++)
		{
			if(i * MinorAbstY % MajorAbstY != 0)
			{
				that.ctx.lineWidth = 1;
				that.ctx.strokeStyle = that.settings.color.tick;
				that.ctx.beginPath();
				that.ctx.closePath();
				ctx.moveTo(TopMP.x - pipeWidth/2 - 2,startY - (i * MinorAbstY)*oneUnit);
				ctx.lineTo(TopMP.x - pipeWidth/2 - MinorWidth - 2, startY - (i * MinorAbstY)*oneUnit);
				that.ctx.stroke();
				
				if (that.settings.minorTicksFont == 1)
				{
					ctx.fillStyle = that.settings.color.tick;
					ctx.textAlign="right";
					ctx.textBaseline="middle";
					ctx.font = that.settings.majorTicksSize*scaleFactor + "px Arial";
					ctx.fillText(min+i * MinorAbstY, TopMP.x - pipeWidth - 10, startY - (i * MinorAbstY)*oneUnit);
				}
			}
		}
	};


    this.setupOptions = setOptions;
    this.setupOptions(options);

    this.setValue = setValue;
    this.setUnit = setUnit;    
    return this;
}
