function ConnectToWebsocket(username)
{
    $("#notconnected").slideUp();
    if(username == undefined) {
        alert("Username undefined!");
        return;
    }
    try 
    {
        websocket = new WebSocket("ws://" + Websocketserver + ":8765");
        websocket.onopen = function(evt) { onOpen(evt, username) };
        websocket.onclose = function(evt) { onClose(evt) };
        websocket.onmessage = function(evt) { onMessage(evt) };
        websocket.onerror = function(evt) { onError(evt) };
    }
    catch(err) 
    {
    }
}

function onOpen(evt, username)
{
    $("#websocketstatus").addClass("ON");
    tryAuth = false;
    doSend(username);
}


function onClose(evt)
{
    $("#websocketstatus").removeClass("ON");
    $("#notconnected").slideDown();
    token = undefined;
    websocket.close();
}


function RequestStatus(Plugs)
{
    var JSON_Data = {};
    JSON_Data.Action = "StatusRequest";
    JSON_Data.PlugIDs = [];
    for(var i = 0; i < Plugs.length; i++)
    {
        JSON_Data.PlugIDs.push(Plugs[i]);
    }
    doJSONTokenSend(JSON_Data);
}

function doJSONTokenSend(Message)
{
    if(token != undefined) {
        Message.Token = token;
        doSend(JSON.stringify(Message));
    }
    else
    {
        TokenMessageStack.push(Message);
    }
}

var tryAuth = false;

function onMessage(evt)
{
    var msg = evt.data;
    if(token == undefined && tryAuth == false)
    {
        doSend(CryptoJS.SHA512(msg + password));
        tryAuth = true;
    }
    else if(token == undefined) {
        token = msg;
        for (i in TokenMessageStack)
            doJSONTokenSend(TokenMessageStack[i]);
    }
    else if(extScope != undefined)
    {
        var JSON_Data = JSON.parse(msg);
        if(JSON_Data.Action == "Status")
        {
            for(Plug in JSON_Data.Plugs)
            {
                var Value = JSON_Data.Plugs[Plug].Value;
                var item = extScope.allItems[Plug];
                if(item != undefined)
                {
                    item.setValue(Value);
                }
            }
            extScope.$apply();
        }
    }
}

function onError(event)
{
        var reason;
        //alert(event.code);
        // See http://tools.ietf.org/html/rfc6455#section-7.4.1
        if (event.code == 1000)
            reason = "Normal closure, meaning that the purpose for which the connection was established has been fulfilled.";
        else if(event.code == 1001)
            reason = "An endpoint is \"going away\", such as a server going down or a browser having navigated away from a page.";
        else if(event.code == 1002)
            reason = "An endpoint is terminating the connection due to a protocol error";
        else if(event.code == 1003)
            reason = "An endpoint is terminating the connection because it has received a type of data it cannot accept (e.g., an endpoint that understands only text data MAY send this if it receives a binary message).";
        else if(event.code == 1004)
            reason = "Reserved. The specific meaning might be defined in the future.";
        else if(event.code == 1005)
            reason = "No status code was actually present.";
        else if(event.code == 1006)
           reason = "The connection was closed abnormally, e.g., without sending or receiving a Close control frame";
        else if(event.code == 1007)
            reason = "An endpoint is terminating the connection because it has received data within a message that was not consistent with the type of the message (e.g., non-UTF-8 [http://tools.ietf.org/html/rfc3629] data within a text message).";
        else if(event.code == 1008)
            reason = "An endpoint is terminating the connection because it has received a message that \"violates its policy\". This reason is given either if there is no other sutible reason, or if there is a need to hide specific details about the policy.";
        else if(event.code == 1009)
           reason = "An endpoint is terminating the connection because it has received a message that is too big for it to process.";
        else if(event.code == 1010) // Note that this status code is not used by the server, because it can fail the WebSocket handshake instead.
            reason = "An endpoint (client) is terminating the connection because it has expected the server to negotiate one or more extension, but the server didn't return them in the response message of the WebSocket handshake. <br /> Specifically, the extensions that are needed are: " + event.reason;
        else if(event.code == 1011)
            reason = "A server is terminating the connection because it encountered an unexpected condition that prevented it from fulfilling the request.";
        else if(event.code == 1015)
            reason = "The connection was closed due to a failure to perform a TLS handshake (e.g., the server certificate can't be verified).";
        else
            reason = "Error - Unknown reason, propaply not started.";
        writeToScreen("Websocket: " + reason);
        //writeToScreen('<span style="color: red;">ERROR:</span> ' + evt.data);
}

function doSend(message)
{
    websocket.send(message);
}

function writeToScreen(text)
{
    $('#output').text(text);
}


function PlugClick(plugnumber)
{
    var JSON_Data = {};
    JSON_Data.Action = "VirtualPlugChanged";
    JSON_Data.PlugID = plugnumber;
    var Module = plugnumber.split('.')[0];
    var Toggle = false;
    if(Module == "variable")
    {
        Toggle = true;
    }
    if($('#' + cssEscape(plugnumber)).hasClass("ON"))
    {
        if(Toggle)
        {
            JSON_Data.Values = [0];
        }
        else
        {
            JSON_Data.Values = [0, 1];
        }
    }
    else
    {
        if(Toggle)
        {
            JSON_Data.Values = [1];
        }
        else
        {
            JSON_Data.Values = [1, 0];
        }
    }
    doJSONTokenSend(JSON_Data);
}

function cssEscape(name)
{
    return name.replace('.', "\\.").replace('#', "\\#");
}

function SendValue(plugnumber)
{
    var JSON_Data = {};
    JSON_Data.Action = "VirtualPlugChanged";
    JSON_Data.PlugID = plugnumber;
    JSON_Data.Values = [];
    JSON_Data.Values.push(extScope.allItems[plugnumber].value);
    doJSONTokenSend(JSON_Data);
}

function Validate(name)
{
    if(name.value == "")
    {
        name.value = "0";
    }
}

