<?php
(require "config.php") or die();
?>



<script>
    addJavascript("js/DateTimePicker.js");
    addStylesheet("css/DateTimePicker.css");

    $("#dtBox").DateTimePicker({
    
        dateFormat: "yyyy-MM-dd",
        timeFormat: "hh:mm:ss",
        dateTimeFormat: "yyyy-MM-dd hh:mm:ss"
    });
    
    var $injector = angular.injector(['ng', 'myApp']);
    $injector.invoke(function($rootScope, $compile) 
    {
        $compile($('#allsignals'))($rootScope);
    });
</script>

<div class="status cf" id="allsignals" ng-controller="overviewController"> 
<!--Display: {{display}}<br/>
Type: {{show.type}}<br/>
Category: {{show.category}}<br/>
Level: {{show.level}}<br/>
Favourite: {{show.favourite}}<br/>
FavouriteFilter: {{show.favouritefilter}}<br/>
Edit: {{show.edit}}<br/>-->
    <div id="dtBox"></div>            


    <div class="tree">
        <div class="treesort cf" ng-if="display!='favourite'">
            <div class="sortitem all noselect" ng-class="{active: display=='all'}" ng-click="changeDisplay('all')"><?php Sprache('all'); ?></div>
            <div class="sortitem level noselect" ng-class="{active: display=='level'}" ng-click="changeDisplay('level')"><?php Sprache('level'); ?></div>
            <div class="sortitem category noselect" ng-class="{active: display=='category'}" ng-click="changeDisplay('category')"><?php Sprache('category'); ?></div>
        </div>
        <ul>
            <li ng-if="display=='all'">
                <div class="statusheadline"><h1><?php Sprache('overview'); ?></h1></div>
                <ul>
                    <li class="cf" ng-class="{active: show.type==''}" ng-click="show.type = ''"><p class="noselect"><?php Sprache('all'); ?></p></li>
                    <li class="cf" ng-class="{active: show.type=='plug'}" ng-click="show.type = 'plug'"><p class="noselect"><?php Sprache('plugs'); ?></p></li>
                    <li class="cf" ng-class="{active: show.type=='variable'}" ng-click="show.type = 'variable'"><p class="noselect"><?php Sprache('variables'); ?></p></li>
                </ul>
            </li>
            <li ng-if="display=='category'">
                <div class="statusheadline"><h1><?php Sprache('category'); ?></h1></div>
                <ul>
                    <li class="cf" ng-repeat="cat in categories" ng-click="show.category = cat.id" ng-class="{active: cat.id==show.category}">
                        <img align="left" ng-src="images/categories/{{cat.image}}" ng-if="cat.image != 'Images'">
                        <p class="noselect">{{cat.name}}</p>
                    </li>
                </ul>
            </li>
            <li ng-if="display=='level'">
                <div class="statusheadline"><img ng-if="currentLevel().id != '-1'" ng-click="show.level = currentLevel().mainid" src="images/arrow-back.png"><h1>{{currentLevel().name}}</h1></div>
                <ul>
                    <li class="cf" ng-click="show.level = lev.id" ng-repeat="lev in levels | strictorall: {mainid: show.level}" ng-class="{active: lev.id==show.level}">
                        <p class="noselect">{{lev.name}}</p>
                    </li>
                </ul>
            </li>      
            <li ng-if="display=='favourite'">
                <div class="statusheadline"><h1><?php Sprache('favourites'); ?></h1></div>
                <ul>
                    <li class="cf" ng-click="show.favourite = fav.favouriteid   " ng-repeat="fav in favourites|unique: 'favouritename'" ng-class="{active: fav.favouriteid==show.favourite}">
                        <img align="right" class="edit" src="images/edit.png" ng-click="setEdit(fav.favouriteid)"></img>
                        <p class="noselect" ng-click="setFavourite(fav.favouriteid)">{{fav.favouritename}}</p>
                    </li>
                </ul>
            </li>
        </ul>
    </div>
    <div class="signals" id="treeplugs">
        <div class="statusheadline"><h1>Plugs</h1></div>
        <ul class="plugs">
            <li class="cf" ng-repeat="(communicateid, Item) in allItems | strictorall: {type: show.type} | strictorall: {categoryid: show.category} | strictorall: {mainlevelid: show.level} | strictorall: {favourite: show.favouritefilter}">
                <p class="plugname">{{Item.name}}</p>
                <div class="inputbox cf" ng-if="show.edit != 'edit'">
                    <label ng-if="Item.prefix!=''">{{Item.prefix}}</label>
                    <div id="{{Item.communicateid}}"    class="{{Item.variabletype}}" 
                                                        ng-class="{
                                                            Input: Item.readonly=='1', 
                                                            Output: Item.readonly!='1', 
                                                            ON: Item.variabletype == 'Boolean' && Item.value=='1',
                                                            PublicValue: Item.type == 'variable'}"
                                                        ng-if="Item.variabletype == 'Boolean'"
                                                        ng-click="plugClick(Item.communicateid)"></div>
                    <div ng-if="Item.variabletype != 'Boolean' && Item.readonly == '0' && Item.type == 'variable'">
                        <input type="number" class="{{Item.variabletype}}" 
                                ng-if="Item.variabletype == 'Int32' || Item.variabletype == 'Double'"
                                ng-class="{Input: Item.readonly=='1', Output: Item.readonly!='1'}" id="{{Item.communicateid}}" min="{{Item.min}}" max="{{Item.max}}" ng-model="Item.value"/>
                        <input type="text" class="{{Item.variabletype}}" 
                                ng-if="Item.variabletype == 'String'"
                                ng-class="{Input: Item.readonly=='1', Output: Item.readonly!='1'}" id="{{Item.communicateid}}" ng-model="Item.value"/>
                        <input type="text" class="DateTime" 
                                ng-if="Item.variabletype == 'DateTime'"
                                ng-class="{Input: Item.readonly=='1', Output: Item.readonly!='1'}" id="{{Item.communicateid}}" min="{{Item.min}}" max="{{Item.max}}" ng-model="Item.value"
                                data-field="datetime" readonly/>                        
                        <input type="text" class="DateTime" 
                                ng-if="Item.variabletype == 'Time'"
                                ng-class="{Input: Item.readonly=='1', Output: Item.readonly!='1'}" id="{{Item.communicateid}}" min="{{Item.min}}" max="{{Item.max}}" ng-model="Item.value"
                                data-field="time" readonly/>
                    </div>
                    <div ng-if="Item.variabletype != 'Boolean' && Item.readonly == '1'">{{Item.value}}</div>
                    <label ng-if="Item.suffix!=''">{{Item.suffix}}</label>
                    <input type="button" value="<?php Sprache('ok');?>" ng-if="Item.variabletype != 'Boolean' && Item.readonly=='0' && Item.type =='variable'" ng-click="sendValue(Item.communicateid)"/>
                </div>
                <div class="favourite" ng-if="show.edit == 'edit'" ng-class="{true: Item.favourite == 'true'}" ng-click="toggleFavourite(Item)"></div>
            </li>     
        </ul>
    </div>
    <input type="button" value="<?php Sprache('save'); ?>" ng-if="show.edit == 'edit'" ng-click="saveFavourites()"/>
</div>
