<?php if(!require "config.php")
{
    return 0;
}
?>
<script>


    var statistic_data={};

    function Variable(Name)
    {
        this.Name = Name;
    }

    $(document).ready(function()
    {
        addJavascript("js/DateTimePicker.js");
        addJavascript("js/highcharts.js");
        addStylesheet("css/DateTimePicker.css");

        
	

        $("#dtBox").DateTimePicker({
        
            dateFormat: "yyyy-MM-dd",
            timeFormat: "hh:mm AA",
            dateTimeFormat: "yyyy-MM-dd hh:mm:ss"

        });

        
        $('div.checkable a.button').bind("click", function(obj)
        {
            $(obj.target).toggleClass("selected");
        });



        $('#diagram').highcharts({
            chart: {
                type: 'line',
                zoomType: 'x'
            },
            title: {
                text: 'RaSmatin'
            },
            xAxis: {
                type: 'datetime',
                dateTimeLabelFormats: {
                    hour: '%H:%M',
                    day: '%e. %b',
                    week: '%e. %b',
                    month: '%b \'%y',
                    year: '%Y'
                },
                title:
                {
                    text: 'Date'
                }
            },
            yAxis: {
                title: {
                    text: 'Values'
                }
            },
            tooltip: {
                headerFormat: '<b>{series.name}</b><br>',
                pointFormat: '{point.x: %Y-%m-%d %H:%M:%S}: {point.y:.2f}'
            }
        });

    });
    
    function format_data()
    {
        for (plug in statistic_data)
        {
            for (i in statistic_data[plug])
            {
                statistic_data[plug][i]["value"] = parseFloat(statistic_data[plug][i]["value"]);
                statistic_data[plug][i]["datetime"] = new Date(Date.parse(statistic_data[plug][i]["datetime"]))
            }
        }
    }

    function set_info(variable)
    {
        this.removeSelected = function(i, obj)
        {
            $(obj).removeClass('selected');
        };
        
        $('#list_plugs li').each(this.removeSelected);
        $('#list_variables li').each(this.removeSelected);
        $('#rb_' + variable.replace(/[!"#$%&'()*+,.\/:;<=>?@[\\\]^`{|}~]/g, "\\$&")).addClass('selected');
        
        var plug_data = statistic_data[variable];
        
        values = [];
        for(i in plug_data)
        {
            values.push(plug_data[i]["value"]);    
        }
        
        values = values.sort(function(a,b){return a - b});
        
        var max = values[values.length - 1];
        var min = values[0];
        var average = (values.reduce(function(a, b) { return a + b; }) / values.length).toFixed(2);
        var median = values.length % 2 == 1 ? values[parseInt(values.length/2)] : (values[values.length/2 - 1] + values[values.length/2])/2;
        $('#variable').text($('#'+variable).text());
        $('#max').text(max);
        $('#min').text(min);
        $('#average').text(average);
        $('#median').text(median);
    }

    function statistic_actualize()
    {
        var variables = [];
        
        if($("#time_start").val() > $("#time_end").val())
        {
            $('#output').text('<?php Sprache('startafterend'); ?>');
            return;
        }
        
        $('div.checkable a.button.selected').each(function(i, obj)
        {
            variables.push($(obj).text());
        });

        if(variables.length == 0)
        {
            $('#output').text('<?php Sprache('novariablesselected'); ?>');
            return;
        }
        
        $.ajax({
            url: "php/status/request_statistic_data.php",
            data:
            {
                starttime: $("#time_start").val(),
                endtime: $("#time_end").val(),
                variables: variables
            }
        }).done(function(data)
        {
            if(data != "" && data != "[]")
            {
                $('#starttime').text($("#time_start").val());
                $('#endtime').text($("#time_end").val());
                statistic_data = JSON.parse(data);
                format_data();
                reloadStatistic();
                $('#list_plugs').empty();
                $('#list_variables').empty();

                $('div.checkable a.button.selected').each(function(i, obj)
                {
                    if(i == 0)
                    {
                    }
                    var container;
                    if($(obj).hasClass("plug"))
                    {
                        container = $('#list_plugs');
                    }
                    else
                    {
                        container = $('#list_variables');
                    }
                    
                    $(container).append('<li id="rb_' + $(obj).attr('id') + '"class="radio variables">' + $(obj).text() +'</li>');
                });
                
                $('#list_plugs li').bind('click', radio_click);
                $('#list_variables li').bind('click', radio_click);
                    
                set_info(variables[0]);
            }
            else
            {
                $('#output').text('<?php Sprache('nodata'); ?>');
            }
        });
    }

    function radio_click(obj)
    {       
        var el = $(obj.currentTarget)
        set_info(el.attr('id').replace('rb_',''));
    }



    function reloadStatistic()
    {
        var chart = $('#diagram').highcharts();

        while(chart.series.length > 0)
        {
            chart.series[0].remove(true);
        }


        for(var i in statistic_data)
        {
            var plug = statistic_data[i];
            var data = [];
            for(var j in plug)
            {
                var date = plug[j]["datetime"];
                var value = plug[j]["value"];
                data.push([date, value]);
            }
            
            chart.addSeries({
                name: $('#' + i.replace(/[!"#$%&'()*+,.\/:;<=>?@[\\\]^`{|}~]/g, "\\$&")).text(),
                data: data
            });
        }

        closeDialog('diagram_config');

    }
    

</script>

<?php
        $now = new DateTime("now");
        $oneweek = clone $now;
        $ti = new DateInterval('P1D');
        $ti->invert = 1;
        $oneweek = $oneweek->add($ti)->format("Y-m-d H:i:s");
        $now = $now->format("Y-m-d H:i:s")
    ?>

    <div id="dtBox"></div>            

    
    <div id="diagram_container">
        <div id="diagram" class="diagram"></div>
        <div id="diagram_info" class="small_info">
            <img class="right_top" src="images/add.gif" alt="Add" onclick="openDialog('diagram_config')"/>
            <h1> <?php Sprache("info"); ?> </h1>
            <h2> <?php Sprache("Starttime"); ?> </h2>
            <p id="starttime"> <?php echo $oneweek; ?> </p>
            <h2> <?php Sprache("Endtime"); ?> </h2>
            <p id="endtime"> <?php echo $now; ?> </p>
            <h2> <?php Sprache("variable"); ?> </h2>
            <p id="variable">----</p>
            <h2> <?php Sprache("min"); ?> </h2>
            <p id="min">0</p>
            <h2> <?php Sprache("max"); ?> </h2>
            <p id="max">0</p>
            <h2> <?php Sprache("average"); ?> </h2>
            <p id="average">0</p>
            <h2> <?php Sprache("median"); ?> </h2>
            <p id="median">0</p>
        </div>
    </div>

    <div id="diagram_variables_container">
        <?php
            function selectDiagramVariables($type)
            {
                require($_SERVER['DOCUMENT_ROOT'] . "/php/main/mysql.php");
                $sql = "SELECT name as Name FROM items WHERE name in (SELECT distinct name FROM diagram_data) AND Type = '$type';";
                $result = mysqli_query($con, $sql);

              
                if(!$result)
                {
                    echo "Error: " . mysqli_error($con);
                }
                else
                {             
                    $variables = [];
                    while($row = mysqli_fetch_object($result))
                    {
                        array_push($variables,$row->Name);
                    }
                    return $variables;
                }

            }
        ?>

        <div id="diagram_plugs" class="small_info">
            <?php
                echo "<h1>";
                Sprache("plugs");
                echo "</h1>";
            ?>
            <ul id="list_plugs">
            </ul>
        </div>

        <div id="diagram_variables" class="small_info">
            <?php
                echo "<h1>";
                Sprache("variables");
                echo "</h1>";
            ?>
            <ul id="list_variables">
            </ul>
        </div>
    </div>

    <div class="dialog" id="diagram_config">
        <img class="right_top" src="images/remove.gif" alt="Close" onclick="closeDialog('diagram_config')"/>
        <?php
        echo "<h1>";
        Sprache("config");
        echo "</h1>";
        ?>
        <div class="flex">
            <label><?php Sprache("Starttime"); ?></label>

            <input id="time_start" class="datetime" type="text" data-field="datetime" value="<?php echo $oneweek;?>" readonly>
	
        </div>
        <div class="flex">
            <label><?php Sprache("Endtime"); ?></label>    
            <input id="time_end"  class="datetime"  type="text" data-field="datetime" value="<?php echo $now;?>" readonly>
        </div>


         <h1> <?php Sprache("plugs"); ?> </h1>
        <div class="checkable">
            <?php
            
            $r = selectDiagramVariables("plug");
            if(!empty($r))
            {
                foreach ($r as $v)
                {
                    ?>
                    <a class="button plug" id="<?php echo $v; ?>"><?php echo $v; ?></a>
                    <?php
                } 
            }

            ?>
        </div>

         <h1> <?php Sprache("variables"); ?> </h1>
        <div class="checkable">
            <?php
            
            $r = selectDiagramVariables("variable");
            if(!empty($r))
            {
                foreach ($r as $v)
                {
                    ?>
                    <a class="button variable" id="<?php echo $v; ?>"> <?php echo $v; ?></a>
                    <?php
                } 
            }

            ?>
        </div>
        <div id="output"></div>
        <input type="button" value="<?php Sprache("actualize");?>" onclick="statistic_actualize()"/>
    </div>

    <?php
