app.directive('thermometer', [function() 
{
  return {
    restrict: 'A',
    replace: true,
    scope: {
      'model': '='
    },
    link: function(scope, elem, attrs) 
    {
        scope.model.setVariable(scope.model, "temperatur").then(function(result)
        {
	    $(elem).thermometer('setUnit', scope.model.temperatur.suffix);
            scope.$watch(function(){return scope.model.temperatur.value;}, function(newVal) 
            {
		var hum = scope.model.humanity;
                var hVal = undefined;
                if(hum !== undefined)
                {
                    hVal = hum.value;
                }
                setValue(newVal, hVal);
            });
        });
        if(scope.model.humanity !== undefined)
        {
            scope.model.setVariable(scope.model, "humanity").then(function(result)
            {
                scope.$watch(function(){return scope.model.humanity.value;}, function(newVal) 
                {
                    setValue(scope.model.temperatur.value, newVal);
                });
            });
        }

        function setValue(temp, hum)
        {
            if(hum === undefined)
            {
                hum = "";
            }
            $(elem).thermometer('setValue',temp, hum);
        }

        $(elem).thermometer(
        {
            color:
            {
                label: 		'#000000',	
                tickLabel: 	'#000000',		
                fill:      	scope.model.fill,
                fill1:     	scope.model.fill2										
            },
            majorTicks: scope.model.major,
            minorTicks: scope.model.minor,
            max: scope.model.max,
            min: scope.model.min,
            unitsLabel: " C",
            minorTicksFont: scope.model.showMinor=='1'
        });
        

    }
  };
}]);

